// tree example 090724

// JavaScript Script for Adobe Illustrator CS3
// Tested with Adobe Illustrator CS3 13.0.3, Windows XP SP2 (Japanese version).
// This script provided "as is" without warranty of any kind.
// Free to use and distribute.

// Copyright(c) 2009 SATO Hiroyuki
// http://lines-about-to-be-generated.blogspot.com/

// 2009-07-24

// Point ------------------------------
function Point(x, y){
  this.x = x;
  this.y = y;

  this.add   = function(p){ return new Point(this.x + p.x, this.y + p.y); }
  this.sub   = function(p){ return new Point(this.x - p.x, this.y - p.y); }
  this.mul   = function(m){ return new Point(this.x * m, this.y * m); }
  this.toa   = function(){ return [this.x, this.y]; }
  this.dist  = function(){ return Math.sqrt(this.x * this.x + this.y * this.y); }
  this.normalize = function(o){
    var d = this.sub(o).dist();
    return d == 0 ? new Point(0, 0) : new Point((this.x - o.x)/d, (this.y - o.y)/d);
  }
  
  this.rot = function(t){
    var c = Math.cos(t);
    var s = Math.sin(t);
    return new Point(this.x * c - this.y * s,
                     this.x * s + this.y * c);
  }
  return this;
}
// ------------------------------------
function branch(count, origin, v, t, len, sw){
  var pnt    = v.rot(t).mul(len).add(origin);
  var handle = v.mul(len * handle_rate).add(origin);

  with(activeDocument.activeLayer.pathItems.add()){
    setEntirePath([ origin.toa(), pnt.toa() ]);
    pathPoints[0].rightDirection = handle.toa();
    filled = false;
    stroked = true;
    strokeWidth = sw;
  }
  
  if(count < branch_limit){
    var offset = sw * (1 - stroke_width_damp) / 2;
    len *= len_damp;
    sw *= stroke_width_damp;
    count += 1;
    v = pnt.normalize(handle);
    branch(count, pnt.add( v.rot(- Math.PI / 2).mul(offset)), v, - rad, len, sw );
    branch(count, pnt.add( v.rot(+ Math.PI / 2).mul(offset)), v, + rad, len, sw );
  }
  return;
}
// ------------------------------------
// settings ---------------------------
var branch_limit = 9;
var len_damp = 0.85;
var stroke_width_damp = 0.65;
var handle_rate = 0.5;

var base_len = 24;
var initial_stroke_width = 4;
var rad = Math.PI / 180 * 8;
var initial_branch = 4;
// ------------------------------------

for(var i = 0; i < initial_branch; i++){
  branch(0, new Point(0, 0),
         new Point(1, 0).rot(Math.PI * 2 / initial_branch * i),
         0, base_len, initial_stroke_width);
}
